// BackColorWindow.cpp: implementation of the CBackColorWindow class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "BackColorWindow.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

BOOL CBackColorWindow::InitSliders()
{
	// Set ranges

	::SendMessage(GetDlgItem(IDC_TB_BACKGROUND_R), TBM_SETRANGE,
		(WPARAM)TRUE, MAKELONG(0, MAX_COLOR_COMPONENT));
	
	::SendMessage(GetDlgItem(IDC_TB_BACKGROUND_G), TBM_SETRANGE,
		(WPARAM)TRUE, MAKELONG(0, MAX_COLOR_COMPONENT));
	
	::SendMessage(GetDlgItem(IDC_TB_BACKGROUND_B), TBM_SETRANGE,
		(WPARAM)TRUE, MAKELONG(0, MAX_COLOR_COMPONENT));


	// Set initial positions
	
	::SendMessage(GetDlgItem(IDC_TB_BACKGROUND_R), TBM_SETPOS,
		(WPARAM)TRUE, TBValueToPos(INITIAL_BACKCOLOR_R));
	::SendMessage(GetDlgItem(IDC_TB_BACKGROUND_G), TBM_SETPOS,
		(WPARAM)TRUE, TBValueToPos(INITIAL_BACKCOLOR_G));
	::SendMessage(GetDlgItem(IDC_TB_BACKGROUND_B), TBM_SETPOS,
		(WPARAM)TRUE, TBValueToPos(INITIAL_BACKCOLOR_B));

	UpdateInfo();
	return TRUE;
}

HRESULT CBackColorWindow::GetBackColor(
		PFLOAT p_pflBackColorR, 
		PFLOAT p_pflBackColorG,
		PFLOAT p_pflBackColorB)
{
	UINT uiPos = 0;
	uiPos = ::SendMessage(GetDlgItem(IDC_TB_BACKGROUND_R), TBM_GETPOS,	0, 0);
	*p_pflBackColorR = TBPosToValue(uiPos);

	uiPos = ::SendMessage(GetDlgItem(IDC_TB_BACKGROUND_G), TBM_GETPOS,	0, 0);
	*p_pflBackColorG = TBPosToValue(uiPos);
	
	uiPos = ::SendMessage(GetDlgItem(IDC_TB_BACKGROUND_B), TBM_GETPOS,	0, 0);
	*p_pflBackColorB = TBPosToValue(uiPos);
	
	return S_OK;
}

BOOL CBackColorWindow::UpdateInfo()
{
	HRESULT hr = E_FAIL;
	TCHAR ptstrInfo[MAX_INFO_STRING];
	
	FLOAT flR, flG, flB;
	
	hr = GetBackColor(&flR, &flG, &flB);
	if (FAILED(hr)) {
		return FALSE;
	}

	_stprintf(ptstrInfo, _T("%+1.2f"), (DOUBLE)flR);
	::SetWindowText(GetDlgItem(IDC_ED_BACKCOLOR_RED), ptstrInfo);

	_stprintf(ptstrInfo, _T("%+1.2f"), (DOUBLE)flG);
	::SetWindowText(GetDlgItem(IDC_ED_BACKCOLOR_GREEN), ptstrInfo);
	
	_stprintf(ptstrInfo, _T("%+1.2f"), (DOUBLE)flB);
	::SetWindowText(GetDlgItem(IDC_ED_BACKCOLOR_BLUE), ptstrInfo);

	return TRUE;
}
