// LightPropsWindow.cpp: implementation of the CLightPropsWindow class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "LightPropsWindow.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////


BOOL CLightPropsWindow::InitSliders()
{
	// Set ranges

	::SendMessage(GetDlgItem(IDC_TB_DIFFUSE_R), TBM_SETRANGE,
		(WPARAM)TRUE, MAKELONG(0, MAX_COLOR_COMPONENT));
	
	::SendMessage(GetDlgItem(IDC_TB_DIFFUSE_G), TBM_SETRANGE,
		(WPARAM)TRUE, MAKELONG(0, MAX_COLOR_COMPONENT));
	
	::SendMessage(GetDlgItem(IDC_TB_DIFFUSE_B), TBM_SETRANGE,
		(WPARAM)TRUE, MAKELONG(0, MAX_COLOR_COMPONENT));


	::SendMessage(GetDlgItem(IDC_TB_AMBIENT_R), TBM_SETRANGE,
		(WPARAM)TRUE, MAKELONG(0, MAX_COLOR_COMPONENT));
	
	::SendMessage(GetDlgItem(IDC_TB_AMBIENT_G), TBM_SETRANGE,
		(WPARAM)TRUE, MAKELONG(0, MAX_COLOR_COMPONENT));
	
	::SendMessage(GetDlgItem(IDC_TB_AMBIENT_B), TBM_SETRANGE,
		(WPARAM)TRUE, MAKELONG(0, MAX_COLOR_COMPONENT));


	::SendMessage(GetDlgItem(IDC_TB_SPECULAR_R), TBM_SETRANGE,
		(WPARAM)TRUE, MAKELONG(0, MAX_COLOR_COMPONENT));
	
	::SendMessage(GetDlgItem(IDC_TB_SPECULAR_G), TBM_SETRANGE,
		(WPARAM)TRUE, MAKELONG(0, MAX_COLOR_COMPONENT));
	
	::SendMessage(GetDlgItem(IDC_TB_SPECULAR_B), TBM_SETRANGE,
		(WPARAM)TRUE, MAKELONG(0, MAX_COLOR_COMPONENT));


	::SendMessage(GetDlgItem(IDC_TB_DIRECTION_X), TBM_SETRANGE,
		(WPARAM)TRUE, 
		MAKELONG(-MAX_VECTOR_COMPONENT, MAX_VECTOR_COMPONENT));
	
	::SendMessage(GetDlgItem(IDC_TB_DIRECTION_Y), TBM_SETRANGE,
		(WPARAM)TRUE, 
		MAKELONG(-MAX_VECTOR_COMPONENT, MAX_VECTOR_COMPONENT));
	
	::SendMessage(GetDlgItem(IDC_TB_DIRECTION_Z), TBM_SETRANGE,
		(WPARAM)TRUE, 
		MAKELONG(-MAX_VECTOR_COMPONENT, MAX_VECTOR_COMPONENT));

	// Set initial positions
	
	::SendMessage(GetDlgItem(IDC_TB_DIFFUSE_R), TBM_SETPOS,
		(WPARAM)TRUE, TBValueToPos(INITIAL_LIGHT_DIFFUSE_R));
	::SendMessage(GetDlgItem(IDC_TB_DIFFUSE_G), TBM_SETPOS,
		(WPARAM)TRUE, TBValueToPos(INITIAL_LIGHT_DIFFUSE_G));
	::SendMessage(GetDlgItem(IDC_TB_DIFFUSE_B), TBM_SETPOS,
		(WPARAM)TRUE, TBValueToPos(INITIAL_LIGHT_DIFFUSE_B));
	
	::SendMessage(GetDlgItem(IDC_TB_AMBIENT_R), TBM_SETPOS,
		(WPARAM)TRUE, TBValueToPos(INITIAL_LIGHT_AMBIENT_R));
	::SendMessage(GetDlgItem(IDC_TB_AMBIENT_G), TBM_SETPOS,
		(WPARAM)TRUE, TBValueToPos(INITIAL_LIGHT_AMBIENT_G));
	::SendMessage(GetDlgItem(IDC_TB_AMBIENT_B), TBM_SETPOS,
		(WPARAM)TRUE, TBValueToPos(INITIAL_LIGHT_AMBIENT_B));

	::SendMessage(GetDlgItem(IDC_TB_SPECULAR_R), TBM_SETPOS,
		(WPARAM)TRUE, TBValueToPos(INITIAL_LIGHT_SPECULAR_R));
	::SendMessage(GetDlgItem(IDC_TB_SPECULAR_G), TBM_SETPOS,
		(WPARAM)TRUE, TBValueToPos(INITIAL_LIGHT_SPECULAR_G));
	::SendMessage(GetDlgItem(IDC_TB_SPECULAR_B), TBM_SETPOS,
		(WPARAM)TRUE, TBValueToPos(INITIAL_LIGHT_SPECULAR_B));

	::SendMessage(GetDlgItem(IDC_TB_DIRECTION_X), TBM_SETPOS,
		(WPARAM)TRUE, TBVectorValueToPos(INITIAL_LIGHT_DIRECTION_X));
	::SendMessage(GetDlgItem(IDC_TB_DIRECTION_Y), TBM_SETPOS,
		(WPARAM)TRUE, TBVectorValueToPos(INITIAL_LIGHT_DIRECTION_Y));
	::SendMessage(GetDlgItem(IDC_TB_DIRECTION_Z), TBM_SETPOS,
		(WPARAM)TRUE, TBVectorValueToPos(INITIAL_LIGHT_DIRECTION_Z));

	UpdateInfo();
	return TRUE;
}

HRESULT CLightPropsWindow::GetDiffuseComponent(
		PFLOAT p_pflDiffuseR, 
		PFLOAT p_pflDiffuseG,
		PFLOAT p_pflDiffuseB)
{
	UINT uiPos = 0;
	uiPos = ::SendMessage(GetDlgItem(IDC_TB_DIFFUSE_R), TBM_GETPOS,	0, 0);
	*p_pflDiffuseR = TBPosToValue(uiPos);

	uiPos = ::SendMessage(GetDlgItem(IDC_TB_DIFFUSE_G), TBM_GETPOS,	0, 0);
	*p_pflDiffuseG = TBPosToValue(uiPos);
	
	uiPos = ::SendMessage(GetDlgItem(IDC_TB_DIFFUSE_B), TBM_GETPOS,	0, 0);
	*p_pflDiffuseB = TBPosToValue(uiPos);

	
	return S_OK;
}

HRESULT CLightPropsWindow::GetAmbientComponent(
		PFLOAT p_pflAmbientR, 
		PFLOAT p_pflAmbientG,
		PFLOAT p_pflAmbientB)
{
	UINT uiPos = 0;
	uiPos = ::SendMessage(GetDlgItem(IDC_TB_AMBIENT_R), TBM_GETPOS,	0, 0);
	*p_pflAmbientR = TBPosToValue(uiPos);

	uiPos = ::SendMessage(GetDlgItem(IDC_TB_AMBIENT_G), TBM_GETPOS,	0, 0);
	*p_pflAmbientG = TBPosToValue(uiPos);
	
	uiPos = ::SendMessage(GetDlgItem(IDC_TB_AMBIENT_B), TBM_GETPOS,	0, 0);
	*p_pflAmbientB = TBPosToValue(uiPos);

	return S_OK;
}


HRESULT CLightPropsWindow::GetSpecularComponent(
		PFLOAT p_pflSpecularR, 
		PFLOAT p_pflSpecularG,
		PFLOAT p_pflSpecularB)
{
	UINT uiPos = 0;
	uiPos = ::SendMessage(GetDlgItem(IDC_TB_SPECULAR_R), TBM_GETPOS, 0, 0);
	*p_pflSpecularR = TBPosToValue(uiPos);

	uiPos = ::SendMessage(GetDlgItem(IDC_TB_SPECULAR_G), TBM_GETPOS, 0, 0);
	*p_pflSpecularG = TBPosToValue(uiPos);
	
	uiPos = ::SendMessage(GetDlgItem(IDC_TB_SPECULAR_B), TBM_GETPOS, 0, 0);
	*p_pflSpecularB = TBPosToValue(uiPos);

	return S_OK;
}

HRESULT CLightPropsWindow::GetLightDirection(
		PFLOAT p_pflDirectionX, 
		PFLOAT p_pflDirectionY,
		PFLOAT p_pflDirectionZ)
{
	INT nPos = 0;
	nPos = ::SendMessage(GetDlgItem(IDC_TB_DIRECTION_X), TBM_GETPOS, 0, 0);
	*p_pflDirectionX = TBPosToVectorValue(nPos);

	nPos = ::SendMessage(GetDlgItem(IDC_TB_DIRECTION_Y), TBM_GETPOS, 0, 0);
	*p_pflDirectionY = TBPosToVectorValue(nPos);
	
	nPos = ::SendMessage(GetDlgItem(IDC_TB_DIRECTION_Z), TBM_GETPOS, 0, 0);
	*p_pflDirectionZ = TBPosToVectorValue(nPos);

	return S_OK;
}
BOOL CLightPropsWindow::UpdateInfo()
{
	HRESULT hr = E_FAIL;
	TCHAR ptstrInfo[MAX_INFO_STRING];
	
	FLOAT flR, flG, flB;
	FLOAT flX, flY, flZ;
	
	hr = GetDiffuseComponent(&flR, &flG, &flB);
	if (FAILED(hr)) {
		return FALSE;
	}
	_stprintf(ptstrInfo, _T("%+1.2f"), (DOUBLE)flR);
	::SetWindowText(GetDlgItem(IDC_ED_DIFFUSE_RED), ptstrInfo);

	_stprintf(ptstrInfo, _T("%+1.2f"), (DOUBLE)flG);
	::SetWindowText(GetDlgItem(IDC_ED_DIFFUSE_GREEN), ptstrInfo);
	
	_stprintf(ptstrInfo, _T("%+1.2f"), (DOUBLE)flB);
	::SetWindowText(GetDlgItem(IDC_ED_DIFFUSE_BLUE), ptstrInfo);

	hr = GetAmbientComponent(&flR, &flG, &flB);
	if (FAILED(hr)) {
		return FALSE;
	}
	_stprintf(ptstrInfo, _T("%+1.2f"), (DOUBLE)flR);
	::SetWindowText(GetDlgItem(IDC_ED_AMBIENT_RED), ptstrInfo);

	_stprintf(ptstrInfo, _T("%+1.2f"), (DOUBLE)flG);
	::SetWindowText(GetDlgItem(IDC_ED_AMBIENT_GREEN), ptstrInfo);
	
	_stprintf(ptstrInfo, _T("%+1.2f"), (DOUBLE)flB);
	::SetWindowText(GetDlgItem(IDC_ED_AMBIENT_BLUE), ptstrInfo);

	hr = GetSpecularComponent(&flR, &flG, &flB);
	if (FAILED(hr)) {
		return FALSE;
	}
	_stprintf(ptstrInfo, _T("%+1.2f"), (DOUBLE)flR);
	::SetWindowText(GetDlgItem(IDC_ED_SPEC_RED), ptstrInfo);

	_stprintf(ptstrInfo, _T("%+1.2f"), (DOUBLE)flG);
	::SetWindowText(GetDlgItem(IDC_ED_SPEC_GREEN), ptstrInfo);
	
	_stprintf(ptstrInfo, _T("%+1.2f"), (DOUBLE)flB);
	::SetWindowText(GetDlgItem(IDC_ED_SPEC_BLUE), ptstrInfo);

	hr = GetLightDirection(&flX, &flY, &flZ);
	if (FAILED(hr)) {
		return FALSE;
	}
	_stprintf(ptstrInfo, _T("%+1.2f"), (DOUBLE)flX);
	::SetWindowText(GetDlgItem(IDC_ED_DIRECTION_X), ptstrInfo);

	_stprintf(ptstrInfo, _T("%+1.2f"), (DOUBLE)flY);
	::SetWindowText(GetDlgItem(IDC_ED_DIRECTION_Y), ptstrInfo);
	
	_stprintf(ptstrInfo, _T("%+1.2f"), (DOUBLE)flZ);
	::SetWindowText(GetDlgItem(IDC_ED_DIRECTION_Z), ptstrInfo);

	return TRUE;
}
