// LightPropsWindow.h: interface for the CLightPropsWindow class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_LIGHTPROPSWINDOW_H__6B752674_8507_4BE6_B409_067B8331B9D0__INCLUDED_)
#define AFX_LIGHTPROPSWINDOW_H__6B752674_8507_4BE6_B409_067B8331B9D0__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "stdafx.h"
#include "Resource.h"
#include "PropertyWindow.h"
#include "CommonDefs.h"

#define INITIAL_LIGHT_DIFFUSE_R		1.0f
#define INITIAL_LIGHT_DIFFUSE_G		1.0f
#define INITIAL_LIGHT_DIFFUSE_B		1.0f

#define INITIAL_LIGHT_AMBIENT_R		0.0f
#define INITIAL_LIGHT_AMBIENT_G		0.0f
#define INITIAL_LIGHT_AMBIENT_B		0.0f

#define INITIAL_LIGHT_SPECULAR_R	0.3f
#define INITIAL_LIGHT_SPECULAR_G	0.3f
#define INITIAL_LIGHT_SPECULAR_B	0.3f

#define INITIAL_LIGHT_DIRECTION_X	+0.0f
#define INITIAL_LIGHT_DIRECTION_Y	+0.0f
#define INITIAL_LIGHT_DIRECTION_Z	-1.0f

class CLightPropsWindow: public CPropertyWindow<CLightPropsWindow>
{

public:
	enum { IDD = IDD_LIGHTPROPERTIES };

/////////////////////////////////////////////////////////////////////////////////////////
// CLightPropsWindow construction/destruction
//
public:

/////////////////////////////////////////////////////////////////////////////////////////
// CLightPropsWindow member variables
//
private:

protected:	

public:
/////////////////////////////////////////////////////////////////////////////////////////
// CLightPropsWindow methods 
//
private:
	BOOL InitSliders();
	BOOL UpdateInfo();

protected:

public:

	HRESULT GetDiffuseComponent(
		PFLOAT p_pflDiffuseR, 
		PFLOAT p_pflDiffuseG,
		PFLOAT p_pflDiffuseB);

	HRESULT GetAmbientComponent(
		PFLOAT p_pflAmbientR, 
		PFLOAT p_pflAmbientG,
		PFLOAT p_pflAmbientB);

	HRESULT GetSpecularComponent(
		PFLOAT p_pflSpecularR, 
		PFLOAT p_pflSpecularG,
		PFLOAT p_pflSpecularB);

	HRESULT GetLightDirection(
		PFLOAT p_pflDirectionX, 
		PFLOAT p_pflDirectionY,
		PFLOAT p_pflDirectionZ);

/////////////////////////////////////////////////////////////////////////////////////////
// CLightPropsWindow message map and message handlers 
//

	BEGIN_MSG_MAP(CLightPropsWindow)
		CHAIN_MSG_MAP(CPropertyWindow<CLightPropsWindow>)
		MESSAGE_HANDLER(WM_INITDIALOG, OnInitDialog)
		MESSAGE_HANDLER(WM_HSCROLL, OnScrolling)
		MESSAGE_HANDLER(WM_VSCROLL, OnScrolling)
	END_MSG_MAP()

	LRESULT OnInitDialog(UINT /*uMsg*/, WPARAM /*wParam*/, 
		LPARAM /*lParam*/, BOOL& /*bHandled*/)
	{
		InitSliders();
		return TRUE;
	}

	LRESULT OnScrolling(UINT p_uMsg, WPARAM p_wParam, LPARAM p_lParam, BOOL& p_bHandled)
	{
		HRESULT hr;hr;
		if (m_pNotifee) {
			m_pNotifee->ParametersChanged(IDD);
		}
		UpdateInfo();
		return 0;
	}

};

#endif // !defined(AFX_LIGHTPROPSWINDOW_H__6B752674_8507_4BE6_B409_067B8331B9D0__INCLUDED_)
