// MaterialPropsWindow.cpp: implementation of the CMaterialPropsWindow class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "MaterialPropsWindow.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

BOOL CMaterialPropsWindow::InitSliders()
{
	// Set ranges

	::SendMessage(GetDlgItem(IDC_TB_DIFFUSE_R), TBM_SETRANGE,
		(WPARAM)TRUE, MAKELONG(0, MAX_COLOR_COMPONENT));
	
	::SendMessage(GetDlgItem(IDC_TB_DIFFUSE_G), TBM_SETRANGE,
		(WPARAM)TRUE, MAKELONG(0, MAX_COLOR_COMPONENT));
	
	::SendMessage(GetDlgItem(IDC_TB_DIFFUSE_B), TBM_SETRANGE,
		(WPARAM)TRUE, MAKELONG(0, MAX_COLOR_COMPONENT));


	::SendMessage(GetDlgItem(IDC_TB_EMISSIVE_R), TBM_SETRANGE,
		(WPARAM)TRUE, MAKELONG(0, MAX_COLOR_COMPONENT));
	
	::SendMessage(GetDlgItem(IDC_TB_EMISSIVE_G), TBM_SETRANGE,
		(WPARAM)TRUE, MAKELONG(0, MAX_COLOR_COMPONENT));
	
	::SendMessage(GetDlgItem(IDC_TB_EMISSIVE_B), TBM_SETRANGE,
		(WPARAM)TRUE, MAKELONG(0, MAX_COLOR_COMPONENT));


	::SendMessage(GetDlgItem(IDC_TB_AMBIENT_R), TBM_SETRANGE,
		(WPARAM)TRUE, MAKELONG(0, MAX_COLOR_COMPONENT));
	
	::SendMessage(GetDlgItem(IDC_TB_AMBIENT_G), TBM_SETRANGE,
		(WPARAM)TRUE, MAKELONG(0, MAX_COLOR_COMPONENT));
	
	::SendMessage(GetDlgItem(IDC_TB_AMBIENT_B), TBM_SETRANGE,
		(WPARAM)TRUE, MAKELONG(0, MAX_COLOR_COMPONENT));


	::SendMessage(GetDlgItem(IDC_TB_SPECULAR_R), TBM_SETRANGE,
		(WPARAM)TRUE, MAKELONG(0, MAX_COLOR_COMPONENT));
	
	::SendMessage(GetDlgItem(IDC_TB_SPECULAR_G), TBM_SETRANGE,
		(WPARAM)TRUE, MAKELONG(0, MAX_COLOR_COMPONENT));
	
	::SendMessage(GetDlgItem(IDC_TB_SPECULAR_B), TBM_SETRANGE,
		(WPARAM)TRUE, MAKELONG(0, MAX_COLOR_COMPONENT));

	::SendMessage(GetDlgItem(IDC_TB_SPECULAR_P), TBM_SETRANGE,
		(WPARAM)TRUE, MAKELONG(0, MAX_COLOR_COMPONENT));
	
	// Set initial positions
	
	::SendMessage(GetDlgItem(IDC_TB_DIFFUSE_R), TBM_SETPOS,
		(WPARAM)TRUE, TBValueToPos(INITIAL_MATERIAL_DIFFUSE_R));
	::SendMessage(GetDlgItem(IDC_TB_DIFFUSE_G), TBM_SETPOS,
		(WPARAM)TRUE, TBValueToPos(INITIAL_MATERIAL_DIFFUSE_G));
	::SendMessage(GetDlgItem(IDC_TB_DIFFUSE_B), TBM_SETPOS,
		(WPARAM)TRUE, TBValueToPos(INITIAL_MATERIAL_DIFFUSE_B));
	
	::SendMessage(GetDlgItem(IDC_TB_EMISSIVE_R), TBM_SETPOS,
		(WPARAM)TRUE, TBValueToPos(INITIAL_MATERIAL_EMISSIVE_R));
	::SendMessage(GetDlgItem(IDC_TB_EMISSIVE_G), TBM_SETPOS,
		(WPARAM)TRUE, TBValueToPos(INITIAL_MATERIAL_EMISSIVE_G));
	::SendMessage(GetDlgItem(IDC_TB_EMISSIVE_B), TBM_SETPOS,
		(WPARAM)TRUE, TBValueToPos(INITIAL_MATERIAL_EMISSIVE_B));

	::SendMessage(GetDlgItem(IDC_TB_AMBIENT_R), TBM_SETPOS,
		(WPARAM)TRUE, TBValueToPos(INITIAL_MATERIAL_AMBIENT_R));
	::SendMessage(GetDlgItem(IDC_TB_AMBIENT_G), TBM_SETPOS,
		(WPARAM)TRUE, TBValueToPos(INITIAL_MATERIAL_AMBIENT_G));
	::SendMessage(GetDlgItem(IDC_TB_AMBIENT_B), TBM_SETPOS,
		(WPARAM)TRUE, TBValueToPos(INITIAL_MATERIAL_AMBIENT_B));

	::SendMessage(GetDlgItem(IDC_TB_SPECULAR_R), TBM_SETPOS,
		(WPARAM)TRUE, TBValueToPos(INITIAL_MATERIAL_SPECULAR_R));
	::SendMessage(GetDlgItem(IDC_TB_SPECULAR_G), TBM_SETPOS,
		(WPARAM)TRUE, TBValueToPos(INITIAL_MATERIAL_SPECULAR_G));
	::SendMessage(GetDlgItem(IDC_TB_SPECULAR_B), TBM_SETPOS,
		(WPARAM)TRUE, TBValueToPos(INITIAL_MATERIAL_SPECULAR_B));
	::SendMessage(GetDlgItem(IDC_TB_SPECULAR_P), TBM_SETPOS,
		(WPARAM)TRUE, TBValueToPos(INITIAL_MATERIAL_SPECULAR_B));

	UpdateInfo();
	return TRUE;
}

HRESULT CMaterialPropsWindow::GetDiffuseComponent(
		PFLOAT p_pflDiffuseR, 
		PFLOAT p_pflDiffuseG,
		PFLOAT p_pflDiffuseB)
{
	UINT uiPos = 0;
	uiPos = ::SendMessage(GetDlgItem(IDC_TB_DIFFUSE_R), TBM_GETPOS,	0, 0);
	*p_pflDiffuseR = TBPosToValue(uiPos);

	uiPos = ::SendMessage(GetDlgItem(IDC_TB_DIFFUSE_G), TBM_GETPOS,	0, 0);
	*p_pflDiffuseG = TBPosToValue(uiPos);
	
	uiPos = ::SendMessage(GetDlgItem(IDC_TB_DIFFUSE_B), TBM_GETPOS,	0, 0);
	*p_pflDiffuseB = TBPosToValue(uiPos);

	
	return S_OK;
}

HRESULT CMaterialPropsWindow::GetEmissiveComponent(
		PFLOAT p_pflEmissiveR, 
		PFLOAT p_pflEmissiveG,
		PFLOAT p_pflEmissiveB)
{
	UINT uiPos = 0;
	uiPos = ::SendMessage(GetDlgItem(IDC_TB_EMISSIVE_R), TBM_GETPOS,	0, 0);
	*p_pflEmissiveR = TBPosToValue(uiPos);

	uiPos = ::SendMessage(GetDlgItem(IDC_TB_EMISSIVE_G), TBM_GETPOS,	0, 0);
	*p_pflEmissiveG = TBPosToValue(uiPos);
	
	uiPos = ::SendMessage(GetDlgItem(IDC_TB_EMISSIVE_B), TBM_GETPOS,	0, 0);
	*p_pflEmissiveB = TBPosToValue(uiPos);

	return S_OK;
}


HRESULT CMaterialPropsWindow::GetAmbientComponent(
		PFLOAT p_pflAmbientR, 
		PFLOAT p_pflAmbientG,
		PFLOAT p_pflAmbientB)
{
	UINT uiPos = 0;
	uiPos = ::SendMessage(GetDlgItem(IDC_TB_AMBIENT_R), TBM_GETPOS,	0, 0);
	*p_pflAmbientR = TBPosToValue(uiPos);

	uiPos = ::SendMessage(GetDlgItem(IDC_TB_AMBIENT_G), TBM_GETPOS,	0, 0);
	*p_pflAmbientG = TBPosToValue(uiPos);
	
	uiPos = ::SendMessage(GetDlgItem(IDC_TB_AMBIENT_B), TBM_GETPOS,	0, 0);
	*p_pflAmbientB = TBPosToValue(uiPos);

	return S_OK;
}


HRESULT CMaterialPropsWindow::GetSpecularComponent(
		PFLOAT p_pflSpecularR, 
		PFLOAT p_pflSpecularG,
		PFLOAT p_pflSpecularB,
		PFLOAT p_pflSpecularP)
{
	UINT uiPos = 0;
	uiPos = ::SendMessage(GetDlgItem(IDC_TB_SPECULAR_R), TBM_GETPOS, 0, 0);
	*p_pflSpecularR = TBPosToValue(uiPos);

	uiPos = ::SendMessage(GetDlgItem(IDC_TB_SPECULAR_G), TBM_GETPOS, 0, 0);
	*p_pflSpecularG = TBPosToValue(uiPos);
	
	uiPos = ::SendMessage(GetDlgItem(IDC_TB_SPECULAR_B), TBM_GETPOS, 0, 0);
	*p_pflSpecularB = TBPosToValue(uiPos);

	uiPos = ::SendMessage(GetDlgItem(IDC_TB_SPECULAR_P), TBM_GETPOS, 0, 0);
	*p_pflSpecularP = TBPosToValue(uiPos);

	return S_OK;
}

BOOL CMaterialPropsWindow::UpdateInfo()
{
	HRESULT hr = E_FAIL;
	TCHAR ptstrInfo[MAX_INFO_STRING];
	
	FLOAT flR, flG, flB, flP;
	
	hr = GetDiffuseComponent(&flR, &flG, &flB);
	if (FAILED(hr)) {
		return FALSE;
	}
	_stprintf(ptstrInfo, _T("%+1.2f"), (DOUBLE)flR);
	::SetWindowText(GetDlgItem(IDC_ED_DIFFUSE_RED), ptstrInfo);

	_stprintf(ptstrInfo, _T("%+1.2f"), (DOUBLE)flG);
	::SetWindowText(GetDlgItem(IDC_ED_DIFFUSE_GREEN), ptstrInfo);
	
	_stprintf(ptstrInfo, _T("%+1.2f"), (DOUBLE)flB);
	::SetWindowText(GetDlgItem(IDC_ED_DIFFUSE_BLUE), ptstrInfo);

	hr = GetEmissiveComponent(&flR, &flG, &flB);
	if (FAILED(hr)) {
		return FALSE;
	}
	_stprintf(ptstrInfo, _T("%+1.2f"), (DOUBLE)flR);
	::SetWindowText(GetDlgItem(IDC_ED_EMISSIVE_RED), ptstrInfo);

	_stprintf(ptstrInfo, _T("%+1.2f"), (DOUBLE)flG);
	::SetWindowText(GetDlgItem(IDC_ED_EMISSIVE_GREEN), ptstrInfo);
	
	_stprintf(ptstrInfo, _T("%+1.2f"), (DOUBLE)flB);
	::SetWindowText(GetDlgItem(IDC_ED_EMISSIVE_BLUE), ptstrInfo);

	hr = GetAmbientComponent(&flR, &flG, &flB);
	if (FAILED(hr)) {
		return FALSE;
	}
	_stprintf(ptstrInfo, _T("%+1.2f"), (DOUBLE)flR);
	::SetWindowText(GetDlgItem(IDC_ED_AMBIENT_RED), ptstrInfo);

	_stprintf(ptstrInfo, _T("%+1.2f"), (DOUBLE)flG);
	::SetWindowText(GetDlgItem(IDC_ED_AMBIENT_GREEN), ptstrInfo);
	
	_stprintf(ptstrInfo, _T("%+1.2f"), (DOUBLE)flB);
	::SetWindowText(GetDlgItem(IDC_ED_AMBIENT_BLUE), ptstrInfo);

	hr = GetSpecularComponent(&flR, &flG, &flB, &flP);
	if (FAILED(hr)) {
		return FALSE;
	}
	_stprintf(ptstrInfo, _T("%+1.2f"), (DOUBLE)flR);
	::SetWindowText(GetDlgItem(IDC_ED_SPECULAR_RED), ptstrInfo);

	_stprintf(ptstrInfo, _T("%+1.2f"), (DOUBLE)flG);
	::SetWindowText(GetDlgItem(IDC_ED_SPECULAR_GREEN), ptstrInfo);
	
	_stprintf(ptstrInfo, _T("%+1.2f"), (DOUBLE)flB);
	::SetWindowText(GetDlgItem(IDC_ED_SPECULAR_BLUE), ptstrInfo);

	_stprintf(ptstrInfo, _T("%+1.2f"), (DOUBLE)flP);
	::SetWindowText(GetDlgItem(IDC_ED_SPECULAR_POWER), ptstrInfo);

	return TRUE;
}
