// MaterialPropsWindow.h: interface for the CMaterialPropsWindow class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_MATERIALPROPSWINDOW_H__F0B8B1B1_DED7_4B09_BA2F_C258AE868826__INCLUDED_)
#define AFX_MATERIALPROPSWINDOW_H__F0B8B1B1_DED7_4B09_BA2F_C258AE868826__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "stdafx.h"
#include "Resource.h"
#include "PropertyWindow.h"
#include "CommonDefs.h"

#define INITIAL_MATERIAL_DIFFUSE_R		0.5f
#define INITIAL_MATERIAL_DIFFUSE_G		0.5f
#define INITIAL_MATERIAL_DIFFUSE_B		0.5f

#define INITIAL_MATERIAL_EMISSIVE_R		0.0f
#define INITIAL_MATERIAL_EMISSIVE_G		0.0f
#define INITIAL_MATERIAL_EMISSIVE_B		0.0f

#define INITIAL_MATERIAL_AMBIENT_R		0.0f
#define INITIAL_MATERIAL_AMBIENT_G		0.0f
#define INITIAL_MATERIAL_AMBIENT_B		0.0f

#define INITIAL_MATERIAL_SPECULAR_R		0.0f
#define INITIAL_MATERIAL_SPECULAR_G		0.0f
#define INITIAL_MATERIAL_SPECULAR_B		0.7f
#define INITIAL_MATERIAL_SPECULAR_P		0.5f

class CMaterialPropsWindow: public CPropertyWindow<CMaterialPropsWindow>
{

public:
	enum { IDD = IDD_MATERIALPROPERTIES };

/////////////////////////////////////////////////////////////////////////////////////////
// CMaterialPropsWindow construction/destruction
//
public:

/////////////////////////////////////////////////////////////////////////////////////////
// CMaterialPropsWindow member variables
//
private:

protected:	

public:
/////////////////////////////////////////////////////////////////////////////////////////
// CMaterialPropsWindow methods 
//
private:
	
protected:
	BOOL InitSliders();
	FLOAT TBPosToValue(UINT p_uiPos) {return (FLOAT(MAX_COLOR_COMPONENT - 
		p_uiPos) / MAX_COLOR_COMPONENT);}
	FLOAT TBValueToPos(FLOAT p_flValue) {return (MAX_COLOR_COMPONENT - 
		UINT(p_flValue * MAX_COLOR_COMPONENT));}

	BOOL UpdateInfo();
public:
	HRESULT GetDiffuseComponent(
		PFLOAT p_pflDiffuseR, 
		PFLOAT p_pflDiffuseG,
		PFLOAT p_pflDiffuseB);
	HRESULT GetEmissiveComponent(
		PFLOAT p_pflEmissiveR, 
		PFLOAT p_pflEmissiveG,
		PFLOAT p_pflEmissiveB);
	HRESULT GetAmbientComponent(
		PFLOAT p_pflAmbientR, 
		PFLOAT p_pflAmbientG,
		PFLOAT p_pflAmbientB);
	HRESULT GetSpecularComponent(
		PFLOAT p_pflSpecularR, 
		PFLOAT p_pflSpecularG,
		PFLOAT p_pflSpecularB,
		PFLOAT p_pflSpecularP);

/////////////////////////////////////////////////////////////////////////////////////////
// CMaterialPropsWindow message map and message handlers 
//

	BEGIN_MSG_MAP(CMaterialPropsWindow)
		CHAIN_MSG_MAP(CPropertyWindow<CMaterialPropsWindow>)
		MESSAGE_HANDLER(WM_INITDIALOG, OnInitDialog)
		MESSAGE_HANDLER(WM_HSCROLL, OnScrolling)
		MESSAGE_HANDLER(WM_VSCROLL, OnScrolling)
	END_MSG_MAP()


	LRESULT OnInitDialog(UINT /*uMsg*/, WPARAM /*wParam*/, 
		LPARAM /*lParam*/, BOOL& /*bHandled*/)
	{
		InitSliders();
		return TRUE;
	}

	LRESULT OnScrolling(UINT p_uMsg, WPARAM p_wParam, LPARAM p_lParam, BOOL& p_bHandled)
	{
		HRESULT hr;hr;
		if (m_pNotifee) {
			m_pNotifee->ParametersChanged(IDD);
		}
		UpdateInfo();
		return 0;
	}

};

#endif // !defined(AFX_MATERIALPROPSWINDOW_H__F0B8B1B1_DED7_4B09_BA2F_C258AE868826__INCLUDED_)
