// MathFunctions.h: interface for the CMathFunctions class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_MATHFUNCTIONS_H__7F60EAAD_3D42_43F4_8A55_E0157B2F21EA__INCLUDED_)
#define AFX_MATHFUNCTIONS_H__7F60EAAD_3D42_43F4_8A55_E0157B2F21EA__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "3DGraphic.h"

class CSplashFunction : public C3DFunction
{
	virtual HRESULT GetXRange(FLOAT* p_pflXMin, FLOAT* p_pflXMax)
	{
		*p_pflXMin = -10.0f;
		*p_pflXMax = +10.0f;
		return S_OK;
	}

	virtual HRESULT GetYRange(FLOAT* p_pflYMin, FLOAT* p_pflYMax)
	{
		*p_pflYMin = -10.0f;
		*p_pflYMax = +10.0f;
		return S_OK;
	}
	virtual HRESULT GetZValue(FLOAT p_flX, FLOAT p_flY, FLOAT* p_pflZ)
	{
		FLOAT flTemp = sqrt(p_flX * p_flX + p_flY * p_flY);
		
		if (flTemp != 0) {
			*p_pflZ = 10.0f * sin(flTemp) / flTemp;
		} else {
			*p_pflZ = 10.0f;
		}
		
		return S_OK;
	}
};

class CPlaneFunction : public C3DFunction
{
	virtual HRESULT GetXRange(FLOAT* p_pflXMin, FLOAT* p_pflXMax)
	{
		*p_pflXMin = -10.0f;
		*p_pflXMax = +10.0f;
		return S_OK;
	}

	virtual HRESULT GetYRange(FLOAT* p_pflYMin, FLOAT* p_pflYMax)
	{
		*p_pflYMin = -10.0f;
		*p_pflYMax = +10.0f;
		return S_OK;
	}
	virtual HRESULT GetZValue(FLOAT p_flX, FLOAT p_flY, FLOAT* p_pflZ)
	{
		*p_pflZ = 5.0f;
		return S_OK;
	}
};

class CParaboloidFunction : public C3DFunction
{
	virtual HRESULT GetXRange(FLOAT* p_pflXMin, FLOAT* p_pflXMax)
	{
		*p_pflXMin = -10.0f;
		*p_pflXMax = +10.0f;
		return S_OK;
	}

	virtual HRESULT GetYRange(FLOAT* p_pflYMin, FLOAT* p_pflYMax)
	{
		*p_pflYMin = -10.0f;
		*p_pflYMax = +10.0f;
		return S_OK;
	}
	virtual HRESULT GetZValue(FLOAT p_flX, FLOAT p_flY, FLOAT* p_pflZ)
	{
		FLOAT flTemp = sqrt(p_flX * p_flX + p_flY * p_flY);
		
		*p_pflZ = -flTemp * flTemp / 10.0;
		return S_OK;
	}
};

#endif // !defined(AFX_MATHFUNCTIONS_H__7F60EAAD_3D42_43F4_8A55_E0157B2F21EA__INCLUDED_)
