// PropertyDialog.h: interface for the CPropertyDialog class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_PROPERTYDIALOG_H__8E30179A_4D76_4352_8A81_560B3F85B6D9__INCLUDED_)
#define AFX_PROPERTYDIALOG_H__8E30179A_4D76_4352_8A81_560B3F85B6D9__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "stdafx.h"
#include "CommonDefs.h"
// Class - sink for notifying about state changes of CPropertyWindow
class CPropertyWindowNotify
{
public:	
	virtual HRESULT HideRequest(UINT p_uiPropWindowID) = 0;
	virtual HRESULT ParametersChanged(UINT p_uiPropWindowID) = 0;
};

template <typename T>
class CPropertyWindow: public CDialogImpl<T>
{

public:
	CPropertyWindow():
		m_pNotifee(NULL)
	{
	}
/////////////////////////////////////////////////////////////////////////////////////////
// CPropertyWindow construction/destruction
//
public:

/////////////////////////////////////////////////////////////////////////////////////////
// CPropertyWindow member variables
//
private:

protected:	
	CPropertyWindowNotify* m_pNotifee;
public:
/////////////////////////////////////////////////////////////////////////////////////////
// CPropertyWindow methods 
//
private:

protected:
	BOOL HidePropertyWindow() 
	{
		ATLASSERT(m_pNotifee);
		if (!m_pNotifee) {
			return FALSE;
		}
		m_pNotifee->HideRequest(T::IDD);
		return TRUE;
	}
public:
	FLOAT TBPosToValue(UINT p_uiPos) {return (FLOAT(MAX_COLOR_COMPONENT - 
		p_uiPos) / MAX_COLOR_COMPONENT);}
	UINT TBValueToPos(FLOAT p_flValue) {return (MAX_COLOR_COMPONENT - 
		UINT(p_flValue * MAX_COLOR_COMPONENT));}

	FLOAT TBPosToVectorValue(INT p_uiPos) {return (-((FLOAT)p_uiPos 
		/ MAX_VECTOR_COMPONENT));}
	INT TBVectorValueToPos(FLOAT p_flValue) {return (
		-(INT)(p_flValue * MAX_VECTOR_COMPONENT));}
	

	BOOL SetNotifee(CPropertyWindowNotify* p_pNotifee)
	{
		ATLASSERT(p_pNotifee);
		m_pNotifee = p_pNotifee;
		return (m_pNotifee != NULL);

	}
/////////////////////////////////////////////////////////////////////////////////////////
// CPropertyWindow message map and message handlers 
//

	BEGIN_MSG_MAP(CPropertyWindow)
		COMMAND_ID_HANDLER(IDOK, OnOK)
		COMMAND_ID_HANDLER(IDCANCEL, OnCancel)
	END_MSG_MAP()

	LRESULT OnOK(WORD /*wNotifyCode*/, WORD wID, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
	{
		HidePropertyWindow();
		return 0;
	}

	LRESULT OnCancel(WORD /*wNotifyCode*/, WORD wID, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
	{
		HidePropertyWindow();
		return 0;
	}

	
};

#endif // !defined(AFX_PROPERTYDIALOG_H__8E30179A_4D76_4352_8A81_560B3F85B6D9__INCLUDED_)
